=== debian/changelog ===
grafx2 (2.5+git20181014-2) unstable; urgency=medium

  * Update liblua dependency to 5.3.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 06 Dec 2018 13:48:04 +0100

grafx2 (2.5+git20181014-1) unstable; urgency=medium

  * New upstream version.
  * debian/control: switch to SDL2.
  * Bump standards version to 4.2.1.
  * debian/watch: updated.
  * debian/README.source: added.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 09 Oct 2018 11:19:51 +0200
