=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export NORECOIL=1
export API=sdl2

%:
	dh $@ --sourcedirectory=src -- depend

override_dh_auto_install:
	@echo Do not use install target of upstream Makefile
