## grafx2 2.5+git20181210

=== src/Makefile ===
--- 
+++ 
@@ -68,7 +68,7 @@
 
   CFLAGS_CACHE = $(OBJDIR)/.cflags.cache
 
-  RECOILVER = 4.3.0
+  RECOILVER = 4.3.1
 
 # Video / input API used
   API ?= sdl
@@ -110,6 +110,7 @@
   PLATFORM = win32
   #some misc files we have to add to the release archive under windows.
   PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
+  PLATFORMFILES += bin/libtiff-5.dll
   ZIP = zip
 else
 
@@ -135,6 +136,8 @@
   else
   ifeq ($(PLATFORM),Darwin) # 2
     #Mac OS X specific
+    # to statically link non system libraries
+    OSX_STATIC ?= 1
 
     # Darwin / OS X versions :
     #  6    => 10.2         ppc only
@@ -179,14 +182,24 @@
     PLATFORMFILES = ../share/grafx2/gfx2.png
     # Where the SDL frameworks are located
     FWDIR = /Library/Frameworks
-    BIN = ../bin/grafx2
+    BIN = ../bin/grafx2-$(API)
 
 ifeq ($(API),sdl)
     SDLCONFIG := $(shell which sdl-config)
 ifneq ($(SDLCONFIG), )
     # these are for use with macports
     SDLCOPT = $(shell sdl-config --cflags)
+  ifeq ($(OSX_STATIC), 1)
+    SDLLOPT = $(shell sdl-config --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
+    SDLLIBDIR = $(shell pkg-config --variable=libdir SDL_image)
+    #SDLLOPT += $(SDLLIBDIR)/libSDL.a
+    SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL_image.dylib $(SDLLIBDIR)/libSDL_ttf.dylib | grep -v SDL | cut -d'.' -f 1))
+    SDLLOPT += $(SDLLIBDIR)/libSDL_image.a
+    TTFLOPT =
+    SDLLOPT += $(shell pkg-config --variable=libdir SDL_ttf)/libSDL_ttf.a
+  else
     SDLLOPT = $(shell sdl-config --libs) $(shell pkg-config --libs SDL_image)
+  endif
 else
     # these are for use with Mac OS X native frameworks
     #-framework SDL_ttf 
@@ -196,15 +209,33 @@
 endif
 ifeq ($(API),sdl2)
     SDLCOPT = $(shell sdl2-config --cflags)
+    #TTFCOPT = $(shell pkg-config --cflags SDL2_ttf)
+  ifeq ($(OSX_STATIC), 1)
+    SDLLOPT = $(shell sdl2-config --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
+    SDLLIBDIR = $(shell pkg-config --variable=libdir SDL2_image)
+    SDLLOPT += $(SDLLIBDIR)/libSDL2.a
+    # trick to get all dependencies
+    SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL2_image.dylib $(SDLLIBDIR)/libSDL2_ttf.dylib | grep -v SDL2 | cut -d'.' -f 1))
+    SDLLOPT += $(SDLLIBDIR)/libSDL2_image.a
+    TTFLOPT =
+    SDLLOPT += $(shell pkg-config --variable=libdir SDL2_ttf)/libSDL2_ttf.a
+  else
     SDLLOPT = $(shell sdl2-config --libs) $(shell pkg-config --libs SDL2_image)
     SDLLOPT += -Wl,-framework,Cocoa
+    TTFLOPT = $(shell pkg-config --libs SDL2_ttf)
+  endif
 endif
 
     # these are for use with macports
-    LUAPKG := $(shell for p in lua5.3 lua-5.3 lua53 lua5.2 lua-5.2 lua52 lua5.1 lua-5.1 lua51 lua ; do pkg-config --exists $$p && echo $$p && break ; done)
+    LUAPKG := $(shell for p in lua lua5.3 lua-5.3 lua53 lua5.2 lua-5.2 lua52 lua5.1 lua-5.1 lua51 ; do pkg-config --exists $$p && echo $$p && break ; done)
 ifneq ($(LUAPKG), )
-    LUACOPT = $(shell pkg-config $(LUAPKG) --cflags)
-    LUALOPT = $(shell pkg-config $(LUAPKG) --libs)
+    ifeq ($(OSX_STATIC),1)
+      LUACOPT = $(shell pkg-config $(LUAPKG) --cflags | sed 's/-I/-idirafter/')
+      LUALOPT = $(shell pkg-config $(LUAPKG) --variable=libdir)/liblua.a
+    else
+      LUACOPT = $(shell pkg-config $(LUAPKG) --cflags)
+      LUALOPT = $(shell pkg-config $(LUAPKG) --libs)
+    endif
 else
     # these are for use with Mac OS X native frameworks
     LUACOPT = -I$(FWDIR)/Lua.framework/Headers
@@ -224,14 +255,21 @@
     LOPT = $(SDLLOPT) $(LUALOPT) -framework libpng14 -lz
 else
     LOPT = $(SDLLOPT) $(LUALOPT)
+    ifneq ($(OSX_STATIC), 1)
+      LOPT += $(TTFLOPT)
+    endif
     LIBPNGCONFIG := $(shell libpng-config)
 ifneq ($(LIBPNGCONFIG), )
     COPT += $(shell libpng-config --cflags)
+    ifneq ($(OSX_STATIC), 1)
     LOPT += $(shell libpng-config --ldflags)
+    endif
 else
     LOPT += -lpng
 endif
+    ifneq ($(OSX_STATIC), 1)
     LOPT += -lz
+    endif
 endif
     COPT += -DENABLE_FILENAMES_ICONV
     LOPT += -liconv
@@ -246,7 +284,7 @@
 endif
     FCLOPT = 
     MACAPPEXE = Grafx2.app/Contents/MacOS/Grafx2
-    NOTTF = 1
+    #NOTTF = 1
   else
   ifeq ($(PLATFORM),AROS) # 3
     #AROS specific
@@ -320,48 +358,3 @@
     #SkyOS specific
     DELCOMMAND = rm -rf
     MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    COPT = -W -Wall -Wdeclaration-after-statement -g $(shell sdl-config --cflags) $(TTFCOPT)
-    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT)
-    OBJDIR = ../obj/skyos
-    ZIP = zip
-
-  else
-  ifeq ($(PLATFORM),OSF1) #9
-    #OSF1 / tru64 alpha
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    ZIP = zip
-    PLATFORMFILES = ../share/grafx2/gfx2.png
-    BIN = ../bin/grafx2
-    COPT = -W -Wall -std=c99 -g -gstabs -D__TRU64__ $(shell sdl-config --cflags) $(TTFCOPT) $(LUACOPT)
-    LOPT = $(shell sdl-config --libs) -lSDL_image $(TTFLOPT) -lpng $(LUALOPT) -lm
-    OBJDIR = ../obj/unix
-    FCLOPT = -lfontconfig
-    COPT += -DUSE_FC
-  else
-  ifeq ($(PLATFORM),FreeMiNT) #10
-    #Atari FreeMiNT/TOS specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir
-    CP = cp
-    ZIP = zip
-    PLATFORMFILES = ../share/grafx2/gfx2.png
-    BIN = ../bin/grafx2.ttp
-    LUALOPT = -llua
-    OBJDIR = ../obj/m68k-atari-mint
-    PLATFORM = m68k-atari-mint
-    STRIP = strip -s 
-    STACK = stack
-    FIX_FLAGS = flags
-    FCLOPT = 
-    COPT = -W -Wall -m68020-60 -fomit-frame-pointer -std=c99 -Wdeclaration-after-statement -D__MINT__ -DNO_INLINE_MATH -O$(OPTIM) -I$(PREFIX)/include `$(PREFIX)/bin/libpng12-config --cflags` `$(PREFIX)/bin/sdl-config --cflags` $(JOYCOPT) $(LUACOPT)
-    LOPT = -static -m68020-60 -lSDL_image `$(PREFIX)/bin/sdl-config --libs` -L$(PREFIX)/lib -ltiff -ljpeg `$(PREFIX)/bin/libpng12-config --libs` -lz -lm $(TTFLOPT) -lfreetype $(LUALOPT) $(LAYERLOPT)
-  else
-  ifeq ($(PLATFORM),syllable) #11
-    #Syllable
