=== tools/test_iff/Makefile ===
CFLAGS = -Wall

.PHONY:	all clean

all: parseiff

clean:
	$(RM) *.o parseiff

parseiff:	parseiff.o
