=== debian/changelog ===
grafx2 (2.5+git20181210-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sat, 08 Dec 2018 13:34:43 +0100
