## grafx2 2.5+git20181211

=== debian/changelog ===
grafx2 (2.5+git20181211-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 11 Dec 2018 09:52:29 +0100
