=== debian/control ===
Source: grafx2
Section: graphics
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libsdl2-dev, libsdl2-image-dev, libsdl2-ttf-dev, liblua5.3-dev | liblua5.1-0-dev, libpng-dev, pkg-config, libfontconfig1-dev, dh-exec
Standards-Version: 4.2.1
Homepage: http://pulkomandy.tk/projects/GrafX2

Package: grafx2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-tuffy
Description: ultimate 256-color bitmap paint program
 This is a bitmap paint program that allows you to draw in more than 60 video
 resolutions (from 320x200 to 1024x768, including most of the standard Amiga
 resolutions: 320x256, 320x512, 640x256, 640x512, and more, provided your
 videocard knows how to handle them).
 .
 This program is dedicated to everybody who knows what a single pixel is. Its
 layout is not very different from the famous Deluxe Paint or Brilliance, so
 it will be quite easy to handle it if you know at least one of these programs.
 If you aren't used to the art of drawing with up to 256 colors, it will be a
 little more difficult for you, but you should give it a try (or more, because
 most of the power of this program won't show up on the first try).
